/** 
 * Big Boss has different attacks and 4 body parts plus turrets.
 */

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

public class BossEnemy extends Enemy
{
    int attackType;
    int timer = 0;
    int countdown = 500;
    int missleShot;
    private int mode = 1;
    boolean acting, moving, attacking, idling, invul, isBody, disabled;
    int ghost = 225;
     
    public BossEnemy() 
    {
        speed          = 2;  
        points         = 9001; //WOOWOOWOOWOO
        shootTimer     = 100;
        health         = 400; //adjust this 
        
        isBoss = invul = acting = isBody = true;    
        attacking = idling = disabled = false;
        
        //setting the costumes
        costumes       = new GreenfootImage[3];
        costumeNumber  = 0;
        for (int i = 0; i < 3; i++)
        {
            costumes[i] = new GreenfootImage("BossBody"+(i+1)+".gif");
        }
        setImage(costumes[0]);
        
        turn(0); //turn it to face down
    }
    
    public void act()
    {
        //make a turret
        if(timer == 10)
        {
            BossTurret b0 = new BossTurret(1);
            getWorld().addObject(b0, getX(), getY());
        }
        
        //Boss is invincible while acting
        if(acting)
        {
            //Moving In
            if(mode == 1)
            {
                move(1);
                if(timer >= 250)
                {
                    acting = false;
                }
            }
            
            //Real Battle
            if(mode == 2)
            {
                //SPAM EXPLOSIONS
                if(countdown % 3 == 0 && countdown > 0)
                {
                    spamEx();
                }
                
                mode2();
                
                if(countdown <= 0)
                {
                    setImage(costumes[1]);
                    acting = false;
                    countdown = 700;
                    
                    //Boss is now vulnerable.
                    invul = false;
                    mode = 3;
                }
            }
            
            //The End
            if(mode == 3)
            {
                //SPAM EXPLOSIONS
                if(countdown % 3 == 0 && countdown > 0)
                {
                    spamEx(); 
                }
                
                mode3();
                
                //Fade away
                if(countdown < 260)
                {
                    fadeOut();
                }
                
                if(countdown == 260)
                {
                    getWorld().addObject(new Kaboom(255), getX(), getY());
                }
                
                if(countdown <= 50)
                {
                    setImage(costumes[2]);
                    //Create Biggest Explosion...
                    
                    getWorld().addObject(new YouWin(), 250, 200);
                    
                    getWorld().removeObject(this);
                }
                
            }
        }
        else //regular actions
        {
            
            if(!disabled)
            {
                setSuit();
                setMode();
               
                if (shootCountdown % shootTimer == 0) 
                {
                    setAttack();
                    attack();    
                }
                
                shootCountdown++;
                
                if(mode == 3)
                    {checkDamaged();}
                
            }
            else
            {
                if(timer % 50 == 0)
                {
                    setSuit();
                }
                
            } 
            //checks whether entire body is disabled
            if(numberOfDis() >= 4)
            {
                acting = true;
                
            }
            
            idle();
        }
        
        timer++;
    }
        
    public void attack() 
    {
        //Missle Barrage
        if(attackType % 6 == 0)//== 1)
        {
            if(!attacking)
            {
                missleShot = 10 * mode;
                shootTimer = 10;
                attacking = true;
            }
                
            if(attacking)
            {
                int x = Greenfoot.getRandomNumber(490) - 245;
                getWorld().addObject(new Missle(), getX() + x, getY() - 10);
                missleShot--;
            }
            
            if(missleShot <= 0)
            {
                attacking = false;
                shootTimer = 100;
            }
        }
    }
    
    public void setAttack()
    {
        int x = Greenfoot.getRandomNumber(100); 
        
        if(attacking)
        {
            attackType = attackType;
        }
        else
        {
            attackType++;
            /*
            if(x >= 30)
                attackType = 0;//Greenfoot.getRandomNumber(5); //5 types of attacks
            else
                attackType = 1;*/
        }
    }
    
    //redefined to keep body part alive.
    public void checkHealth()
    {
        if(health <= 0)
        {
            Player p = getPlayer();
            p.addScore(points);   
            disabled = true;
        }
    }

    public void idle()//REFERENCE TO BODY
    {
        if(timer % 5 == 0)
        {
            if(!getIdle())
                move(1);
            else
                move(-1);
        }
        
        if(timer % 60 == 0)
            setIdle();
    }
    
    public void spreadShot()
    {
        BossEnemy b = getBody();
        if(b.getMode() == 3)
        {
            Bullet[] bulls = new Bullet[10]; 
            //aim them all accordingly
            for(int d = 0; d < bulls.length; d++) 
            {
                bulls[d] = new Bullet(180 - (d*18)); 
            }
            //fire them all
            for(Bullet x : bulls)
            {
                getWorld().addObject(x, getX(), getY());
            }
            //pew
            //Greenfoot.playSound("EnergyGun.wav");  
        }
    }
    
    public void setMode()
    {
        if(getTurrets() <= 0)
        {
            if(invul == true){
                mode = 2;
                acting = true;
            }
            else
            {return;}
        }
    }
    
    public void setSuit()
    {
        BossEnemy b = getBody();
        
        if(!this.getDis())
        {
            if(b.getMode() == 1)
            {setCostNum(0);}
            else if(b.getMode() == 3)
            {setCostNum(1);}
            else
            {setCostNum(2);
             System.out.println("PROBLEM");}
        }else
        {
            if(this.getCostNum() == 1)
            {setCostNum(2);
            }else
            {setCostNum(1);}
        }
        
        setImage(costumes[getCostNum()]);
    }
    
    public void setInvul()
    {
       if(mode > 1 && !acting)
            invul = false;
       else
            invul = true;
    }
    
    //creates an Explosion on a random part of the Boss.
    public void spamEx()
    {
        Explosion q = new Explosion("small");
                    
        int x = 50 + Greenfoot.getRandomNumber(400);
        int y = Greenfoot.getRandomNumber(200);
        
        getWorld().addObject(q, x, y);   
    }
    
    //mode methods change costumes
    
    public void mode2()
    {
        int change = 20;
        
        if(countdown < 100)
        {
            change = 5;
        }
        
        if(countdown < 240 && countdown % change == 0)
        {
            setImage(costumes[costumeNumber]);
            costumeNumber++;
            if(costumeNumber > 1){
                costumeNumber = 0;
            }
        }
        
        countdown--;
    }
    
    public void mode3()
    {
        int change = 10;
        
        if(countdown < 500)
        {
            change = 5;
        }
        
        if(countdown > 50 && countdown % change == 0)
        {
            if(costumeNumber > 2){
                costumeNumber = 1;
            }
            setImage(costumes[costumeNumber]);
            costumeNumber++;
        }
        
        countdown--;
    }
    
    public BossEnemy getBody()
    {
        List<BossEnemy> b = getWorld().getObjects(BossEnemy.class);
        for(BossEnemy c : b)
        {
            if(c.getIsBody())
                return c;
        }
        return null;
    }
    
    //returns number of disabled bodyparts.
    public int numberOfDis()
    {
        int count= 0;
        List<BossEnemy> b = getWorld().getObjects(BossEnemy.class);
        for(BossEnemy c : b)
        {
            if(c.getDis() == true)
            {
                count++;
            }
        }
        return count;
    }
    
    public int getMode()
    {
        return mode;
    }
    
    public boolean getInvul()
    {
        return invul;
    }
    
    public boolean getAct()
    {
        return acting;
    }
    
    public boolean getIsBody()
    {
        return isBody;
    }
    
    public boolean getIdle()
    {
        return idling;
    }
    
    public boolean getDis()
    {
        return disabled;
    }
      
    public boolean getAttacking()
    {
        return attacking;
    }
    
    public int getAttackType()
    {
        return attackType;
    }
    
    public int getTurrets()
    {
        FirstLevel level = (FirstLevel)getWorld();
        List<BossTurret> t = level.getObjects(BossTurret.class); 
        return t.size();
    }
    
    public int getCostNum()
    {
        return costumeNumber;
    }
    
    public int getGhost()
    {
        return ghost;
    }
    
    public void setCostNum(int x)
    {
        costumeNumber = x;
    }
    
    public boolean hasTurret()
    {
        BossTurret turr = (BossTurret)getOneIntersectingObject(BossTurret.class);
        return (turr!=null);
    }
    
    public void addMode()
    {
        mode++;
    }
    
    public void setIdle()
    {
        idling = !idling;
    }
    
    public void fadeOut()
    {
        if (ghost > 0) {
            getImage().setTransparency(ghost);
            ghost-=1;
        }
    }
}
