/**
 * The Head of the BossEnemy. 
 */


import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
public class BossHead extends BossEnemy
{

    public BossHead()  
    {
        speed          = 2;  
        points         = 9001; //WOOWOOWOOWOO
        shootTimer     = 100;
        health         = 200; //adjust this 
        isBoss         = true;    
        isBody         = false;
        disabled       = false;
        
        //setting the costumes
        costumes       = new GreenfootImage[3];
        costumeNumber  = 0;
        for (int i = 0; i < 3; i++)
        {
            costumes[i] = new GreenfootImage("BossHead"+(i+1)+".gif");
        }

        setImage(costumes[0]);
        
        turn(0); //turn it to face down
    }

    public void act()
    {
        //doesn't make turret
        BossEnemy b = getBody();
        if(b==null)
        {
            getWorld().removeObject(this);
        }
        else
        {
            if(b.getAct())
            {
                if(b.getMode() == 1)
                {
                    move(1);
                }
                
                if(b.getMode() == 2)
                {
                    mode2();
                    if(countdown <= 0)
                    {
                        setImage(costumes[1]);
                        acting = false;
                        countdown = 700;
                    }
                }
                
                if(b.getMode() == 3)
                {
                    mode3();
                    
                    if(countdown < 260)
                    {
                        fadeOut(); 
                    }
                    
                    if(countdown == 260)
                    {
                        getWorld().addObject(new Kaboom(255), getX(), getY());
                    }
                    
                    if(countdown <= 50)
                    {
                        setImage(costumes[2]);
                        
                        getWorld().removeObject(this);
                    }
                }
            }
            else
            {
                if(!disabled)
                {
                    setSuit();
    
                    shootCountdown++;
                    
                    if(b.getMode() == 3)
                    {
                        if (this != null && shootCountdown % shootTimer == 0)   //This times the Enemy's shooting
                        {
                           // setAttack();
                            attack();    
                        }
                        checkDamaged();
                    }
                    
                }else
                {
                    if(timer % 50 == 0)
                    {
                        setSuit();
                    }
                } 
                
                idle();
            }
            timer++;
        }
    }
    
    public void setAttack()
    {
        int x = Greenfoot.getRandomNumber(100); 
        
        if(attacking)
        {
            attackType = attackType;
        }
        else
        {
            if(x >= 30)
                attackType = 0;//Greenfoot.getRandomNumber(5); //5 types of attacks
            else
                attackType = 1; 
        }
    }
    
    public void attack() 
    {
        BossEnemy b = getBody();
        
        if(b.getAttacking() == false && b.getAttackType() % 2 != 0) //== 0)
        {
            //Default Spread Shot
            spreadShot();
        }
        
    }
    
   
}
