/**
 * The Right wing of the BossEnemy. Houses one Turret and fires spreadShot.
 */


import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
public class BossRight extends BossEnemy
{
    public BossRight() 
    {
        speed          = 2;  
        points         = 9001; //WOOWOOWOOWOO
        shootTimer     = 100;
        health         = 100; //adjust this 
        isBoss         = true;    
        isBody         = false;
        disabled       = false;
        
        //setting the costumes
        costumes       = new GreenfootImage[3];
        costumeNumber  = 0;
        for (int i = 0; i < 3; i++)
        {
            costumes[i] = new GreenfootImage("BossRight"+(i+1)+".gif");
        }

        setImage(costumes[0]);
        
        turn(0); //turn it to face down
    }
    
    public void act()
    {
        BossEnemy b = getBody();
        if(b == null)
        {
            getWorld().removeObject(this);
        }
        else
        {
            if(timer == 15)
            {
                BossTurret b0 = new BossTurret(2);
                getWorld().addObject(b0, getX(), getY());
            }
        
            if(b.getAct())
            {
                if(b.getMode() == 1)
                {
                    move(1);
                }
                if(b.getMode() == 2)
                {
                    mode2();
                    if(countdown <= 0)
                    {
                        setImage(costumes[1]);
                        acting = false;
                        countdown = 700;
                    }
                }
                if(b.getMode() == 3)
                {
                    mode3();
                    
                    if(countdown < 260)
                    {
                        fadeOut();
                    }
                    
                    if(countdown == 260)
                    {
                        getWorld().addObject(new Kaboom(255), getX(), getY());
                    }
                    
                    if(countdown <= 50)
                    {
                        setImage(costumes[2]);
                         
                        getWorld().removeObject(this);
                    }
                }
            }
            else //regular actions
            {
               
                if(!disabled)
                {
                    setSuit();
                    //setMode();
                    shootCountdown++;
                    
                    if(b.getMode() == 3)
                    {
                        if (this != null && shootCountdown % shootTimer == 0)   //This times the Enemy's shooting
                        {
                            //setAttack();
                            attack();    
                        }
                        checkDamaged();
                    }
                }else
                {
                    if(timer % 50 == 0)
                    {
                        setSuit();
                    }
                }
                
                idle();
            }
            timer++;
        }
    }
    
    public void setAttack()
    {
        int x = Greenfoot.getRandomNumber(100); 
        
        if(attacking)
        {
            attackType = attackType;
        }
        else
        {
            if(x >= 30)
                attackType = 0;//Greenfoot.getRandomNumber(5); //5 types of attacks
            else
                attackType = 1;
        }
    }
    
    public void attack() 
    {
        BossEnemy b = getBody();
        
        if(b.getAttacking() == false && b.getAttackType() % 2 == 0)
        {
            //Default Spread Shot
            spreadShot();
        }
        else if(b.getAttackType() == 1)
        { 
            return;
        }
        else 
        {return;
        }
        
    }
    
    public void stayWithBody()
    {
        BossEnemy b = getBody();
        
        setLocation(b.getX() + 200, b.getY());
    }
}
