import greenfoot.*;
import java.util.List;
/**
 * Base on Boss Wings for Bullets to spawn.
 * Rotates in slow arch and shoots.
 * Must be destroyed first in Boss Battle.
 */
public class BossTurret extends Enemy
{
    private int x;
    private int y;
    private int direction;
    int timer = 0;

    private boolean goLeft; 

    public BossTurret(int left) 
    {
        points = 300;
        goLeft = true;
        health = 50;
        
        if(left == 0)
        {
            x = -160;
            y = 20;
        }
        else if(left == 1)
        {
            x = 0;
            y = 60;
        }
        else
        {
            x = 160;
            y = 20;
        }
        
        direction = 90;
        setRotation(direction);
    }

    public void act()
    {
        spin();
        attack();

        BossEnemy b = getBody();
        
        if(b != null){
            setLocation(b.getX() + x, b.getY() + y);}
        else{
            getWorld().removeObject(this);
            System.out.println("BLAAAAGH");}
            
        timer++;
        checkDamaged();
        
    }
    
    public void attack()
    {
        if(timer % 30 == 0)
        {
            Bullet b = new Bullet(direction);
            getWorld().addObject(b, getX(), getY());
        }
    }
    
    public void spin()
    {
        if(goLeft)
        {direction += 1;}
        else
        {direction -= 1;}
        
        if(direction >= 180)
        {goLeft = false;}
        if(direction <= 0)
        {goLeft = true;}
         
        setRotation(direction);
    }
    
    //returns the main body of Boss.....somehow.....
    public BossEnemy getBody()
    {
        FirstLevel level = (FirstLevel)getWorld();
        List<BossEnemy> b = level.getObjects(BossEnemy.class);
        if(b.size() > 0)
            return b.get(0);
        else
            return null;
    }
    
    //Overridden to add Kaboom
    public void checkHealth()
    {
        if(health <= 0)
        {
            Player p = getPlayer();
            p.addScore(points);   
            getWorld().addObject(new Kaboom(), getX(), getY());
            getWorld().removeObject(this);
        }
    }

    public int getDirection()
    {
        return direction;
    }
    
    /**
     * Unused for now. Aims at Player.
     */
    public void aim()
    {
        Player p = getPlayer();
        
        if(p != null)
        {
            int xp = p.getX();
            int yp = p.getY();
            
            int degrees = Toolkit.absoluteBearing(xp, yp, getX(), getY());
            
            setRotation(degrees);
        }
        
    }
}