import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * Default Bullet moves straight down.
 * Directional Bullet moves in direction it's given.
 */

public class Bullet extends EnemyProjectile
{
    GreenfootImage[] costumes = new GreenfootImage[4];
    int costumeNumber = 0; 
    
    //Constructor -- makes a new bullet object
    //Default
    public Bullet()//int cost)
    {
        speed = 6;
        direction = 90;
        setRotation(direction);
                
        for (int i = 0; i < 4; i++)
        {
            costumes[i] = new GreenfootImage("MissleRed_0"+(i+1)+".gif");
        }
    }
    
    //Directional
    public Bullet(int dir)
    {
        speed = 5;
        direction = dir;
        setRotation(direction);  //make it face 
        
        for (int i = 0; i < 4; i++)
        {
            costumes[i] = new GreenfootImage("LazerballRed_0"+(i+1)+".gif");
        }
    }
    
    public void act()
    {        
        costumeNumber++;
        if(costumeNumber > 3){
            costumeNumber = 0;
        }
        setImage(costumes[costumeNumber]);
        
        if(offScreen()) {
            getWorld().removeObject(this);
        } else {
            move(speed);
        }
    }
}