import greenfoot.*;

/**
 * Buttons appear alongside the TitleScreen.
 * Passing over one with the Player activates the button.
 */

public abstract class Button extends Actor
{
    boolean activated = false;
    int mode; 
    
    GreenfootImage[] costumes = new GreenfootImage[2]; 
    int costumeNumber = 0;
    
    public void act() 
    {
        checkDamaged();
        
        setCostume();
    }
    
    public void checkDamaged()
    {
        Player p = (Player) getOneIntersectingObject(Player.class);
        
        if(p!=null)
        {activated = true;}
        else
        {activated = false;}
    }
    
    public void setCostume()
    {
        if(!activated)
        {setImage(costumes[0]);}
        else
        {setImage(costumes[1]);}
    }
    
    public boolean getActive()
    {
        return activated;
    }
    
}