import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
/**
 * Creates waves of Enemys (as well as Powerups).
 * Enemys get stronger at each stage.
 */

public class EnemyGenerator extends Actor 
{
    private int timer = 0;
    private int stage;                  //the level of the game
    private boolean bossTime = false;   //lol boolean
    private boolean stop = false;
    
    
    public void act() 
    {
        timer++;
        //possibly make other timed events....dialoge? witty banter?

        if(timer > 7250) // Timed with music
        {
            bossTime = true;
        } 
        
        if(getPlayer() != null)
        {
            if (timer % 500 == 0)
            {
                makePow();
            }
            
            if(!stop)
            {
                if(!bossTime) 
                {
                    if (timer % 80 == 0) {
                        basicWave(10, 490);
                    }
                    
                    if (timer % 100 == 0) {
                        suicideWave(10, 490);
                    }
                    
                    if (timer % 150 == 0) {
                        randomWave(10, 490);
                    }
                }
                else
                {
                    bossWave();
                    stop = true;
                }
            }
        }
        
        //for Boss testing purposes
        /* 
        if (timer == 100)
        {
            bossWave();
        }
        if (timer % 500 == 0)
        {
            makePow();
        } */
    }    
    
    //Creates a wave of Enemys between the 2 given x-coordinates with the given health.
    public void basicWave(int x1, int x2) 
    {
        int x = x1 + Greenfoot.getRandomNumber( x2 - x1 ); //getWorld().getWidth() - 20);
        //pick a random x coordinate for placing the enemy
        //between the given points
        
        BasicEnemy be = new BasicEnemy(4 * (1 + stage) ); //1 + (getTotalScore() / 15) );        
        //health goes up by 4 each stage
        
        getWorld().addObject(be, x, -20);
        //add the new enemy object to the world
    }    
    public void randomWave(int x1, int x2) 
    {
        int x = x1 + Greenfoot.getRandomNumber( x2 - x1 ); // getWorld().getWidth() - 20);
        
        RandomEnemy re = new RandomEnemy(6 * (1 + stage) );  
        //health goes up by 6 each stage
        
        getWorld().addObject(re, x, -20);
    }    
    
    /**
     * These two Enemys could use some work....
     */
    public void suicideWave(int x1, int x2) 
    {
        int x = x1 + Greenfoot.getRandomNumber( x2 - x1 ); //getWorld().getWidth() - 20);
        
        SuicideEnemy su = new SuicideEnemy(2 + stage);    
        //health goes up by 2 each stage 
        
        getWorld().addObject(su, x, -20);
    }    
    public void zipWave(int x1, int x2) 
    {
        int x = x1 + Greenfoot.getRandomNumber( x2 - x1 ); //getWorld().getWidth() - 20);
        
        ZipEnemy zi = new ZipEnemy(2 + stage);    
        //health goes up by 2 each stage 
        
        getWorld().addObject(zi, x, -20);
        
    }    
    
    //Make a Boss.
    public void bossWave()
    {
        BossEnemy be = new BossEnemy();
        BossHead  bh = new BossHead();
        BossLeft  bl = new BossLeft();
        BossRight br = new BossRight();
        getWorld().addObject(be, 250, -200);
        getWorld().addObject(bh, 250, -80);
        getWorld().addObject(bl, 130, -200);
        getWorld().addObject(br, 370, -200);
    }
    
    //Make a Powerup
    public void makePow()
    {
        int x = Greenfoot.getRandomNumber( 500 );
        
        //TEST POWERUPS WITH THIS
        int h = getChance();//1 + Greenfoot.getRandomNumber(8);
        
        Powerup pu = new Powerup(h, 0); 
        getWorld().addObject(pu, x, 10);
    }
    
    public int getChance()
    {
        int ran = Greenfoot.getRandomNumber(100);
        //returns Powerup type based on percentage 
        if(ran <= 6)
            return 1;
        else if(ran <= 25)
            return 2;
        else if(ran <= 38)
            return 3;
        else if(ran <= 51)
            return 4;
        else if(ran <= 64)
            return 5;
        else if(ran <= 77)
            return 6;
        else if(ran <= 94)
            return 7;
        else
            return 8;
    }
    
    public void setStage(int y)
    {
        stage = y;
    }
    
     public EnemyGenerator(int s)
    {
        stage = s;
    }

    public int getTotalScore()
    {
        return getPlayer().getScore();
    }
    
    public Player getPlayer()
    {
        FirstLevel level = (FirstLevel)getWorld();
        return level.getPlayer();
    } 
}
