import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
/**
 * Cosmetic Explosion effect.
 * Single to indicate Projectile collision with Player or Enemy.
 * Multiple usually indicates death.
 */

public class Explosion extends Actor
{
    GreenfootImage[] costumes = new GreenfootImage[25];
    int costumeNumber = 0; 

    public Explosion(String size)
    {
        if(size.equals("small"))
        {
            for (int i = 0; i < 25; i++)
            {
                costumes[i] = new GreenfootImage("explosion_"+(i+1)+".gif");
            }
        }
        else if(size.equals("big"))
        {
            for (int i = 0; i < 25; i++)
            {
                costumes[i] = new GreenfootImage("bigex_"+(i+1)+".gif");
            }
        }
        else
        {
            /*
             * This explosion came from the main Sprite Sheet.
             */ 
            for(int i = 0; i < 8; i++)
            {
                costumes[i] = new GreenfootImage("boom_0"+(i+1)+".gif");
            }
        }
        
        //turn the explosion at a random angle        
        int randomAngle = Greenfoot.getRandomNumber(359);
        setRotation(randomAngle);
    }

    public void act() 
    {
        //setImage(costumes[costumeNumber / 3]);
        setImage(costumes[costumeNumber]);
        costumeNumber++;
        if (costumeNumber > 24)//21)
            getWorld().removeObject(this);
    }    
}