import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class FirstLevel extends World
{
    private Player p1;     
    private LifeCounter lf;
    private Scoreboard sc; 
    private EnemyGenerator eg;
    private EnvironmentGenerator vg; //didn't think i'd need this....
    
    /**
     * SOUNDS IN PROGRESS
     */
    
    private GreenfootSound music;
    private GreenfootSound laser;
    private GreenfootSound pomsn;
    
    private Sounds so;
    
    public FirstLevel()
    {    
        super(500, 500, 1, false);
        // This creates a new world with 500x500 cells 
        // with a cell size of 1x1 pixels.  The 
        // false is optional, and makes it so sprites 
        // can go beyond the edge of the screen
        
        setBackground("blackbackground.jpg");
        
        music = new GreenfootSound("Goukisan - Guitar vs piano 1.2.mp3");
        laser = new GreenfootSound("EnergyGun.wav");
        pomsn = new GreenfootSound("pomson.wav"); 
        
        TitleScreen ts = new TitleScreen(); 
        addObject(ts, 250, 250);
        
        setPaintOrder(GameOver.class, Explosion.class, Player.class, LifeCounter.class,
                      Powerup.class, MyBullet.class, Bullet.class, MyScatter.class,
                      MyBlackHole.class, MyMissle.class, Missle.class,
                      SuicideEnemy.class, BasicEnemy.class, RandomEnemy.class, 
                      BossTurret.class,
                      BossLeft.class, BossRight.class, BossHead.class, BossEnemy.class,
                      Continue.class, CreditScreen.class, InstructScreen.class, VersionScreen.class,
                      InstructButton.class, CreditsButton.class, VersionButton.class,
                      Star.class, TitleScreen.class);
                         
    }
    
    public void setPlayer (Player p)
    {
        p1 = p;
        addObject(p1, 250, 400);
        
        // This creates a new Player object.
    }
    
    public void setScoreboard (Scoreboard s)
    {
        sc = s;
        addObject(sc, 50, 450);
        
        //This creates a new Scoreboard Object
        //points for kills are assigned through 
        //Player object
    }
    
    public void setLifeCounter (LifeCounter l)
    {
        lf = l;
        addObject(lf, 450, 450);
        
        //This creates a new LifeCounter Object
    }
    
    public void setEnemyGenerator (EnemyGenerator g)
    {
        eg = g;
        addObject(eg, -10, -10);
        
        // This creates a new EnemyGenerator object,
        // which is what times the waves of enemies.
    }
    
    public void setEnvironmentGenerator (EnvironmentGenerator v)
    {
        vg = v;
        addObject(vg, -11, -10);
        //EviroGen spams stars for cosmetic effect
    }
    
    //IN PROGRESS
    public void setSounds(Sounds s)
    {
        so = s;
        addObject(so, -5, -8);
        //Sounds is responsible for all music and sound effects.
    }
    
   
    public Player getPlayer()
    {
        if(p1 == null)
            return null;
        else
            return p1;
    }
    
    public Scoreboard getScoreboard()
    {
        return sc;
    }
    
    public LifeCounter getLifeCounter()
    {
        return lf;
    }

    public EnvironmentGenerator getEnvironmentGenerator()
    {
        return vg;
    }
    
    /**
     * IN PROGRESS
     */
    
    public Sounds getSounds()
    {
        return so;
    }
    
     public void playMusic()
    {
        music.play();
    }
    
    public void playLaser()
    {
        laser.play();
    }
    
    public void playPomsn()
    {
        pomsn.play();
    }
    
    public void stopMusic()
    {
        music.stop();
    }
    
}
