import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;

/**
 * Visually shows the amount of lives the Player has.
 */
 
public class LifeCounter extends Actor
{
    private int lives, maxLives, costumeNumber;
    GreenfootImage[] costumes = new GreenfootImage[5];
    
    //default constructor has 5 lives
    public LifeCounter(int v)
    {
        lives           = v;
        maxLives        = v;
        costumeNumber   = lives - 1;
        
        //setting the costumes
        for (int i = 0; i < lives; i++)
        {
            costumes[i] = new GreenfootImage("jetfighterMINI"+(i+1)+".png");
        }
        setImage(costumes[costumeNumber]); 
    }
    
    public void act()
    {
        drawLife();
    }
    
    public void drawLife()
    {
        if(lives == 0) //if dead, hide.
            getImage().setTransparency(0);
            
        costumeNumber = lives - 1;
        
        if(costumeNumber >= 0) 
            setImage(costumes[costumeNumber]);
    }
    
    public int getLives()
    {
        return lives;
    }
    
    public void loseLife()
    {
        if(lives > 0)
            lives--;
    }
    
    public void addLife()
    {
        if(lives < maxLives)
            lives++;
    }
    
    public void setLives(int x)
    {
        if(x <= maxLives){
            lives = x;
        }
        else{
            lives = maxLives;
        }
    }
    
    public int getMaxLives()
    {
        return maxLives;
    }
}

//LIFE IS LIFE
//NA NAAA NAAA NANA