import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)
/**
 * Powerups travel down the World and contain a random int from 1-8.
 * When a Player collides with the Powerup, the Player gains either a new Gun or power.
 */

public class Powerup extends Actor 
{
    private int speed;      //how fast the powerup travels
    private int direction;  //direction of the powerup in degrees
    private int type;       //the type of powerup

    //Constructor -- makes a new powerup object
    public Powerup(int t, int dir)
    {
        speed       = 2;
        type        = t;
        direction   = dir; 
        setRotation(direction);  //make it face 
        
        if(type == 1)
            setImage(new GreenfootImage("redhealth.png"));
        else if(type == 2)
            setImage(new GreenfootImage("bluehealth.png"));
        else if(type == 3)
            setImage(new GreenfootImage("pickshield.png"));
        else if(type == 4)
            setImage(new GreenfootImage("pickmissle.png"));
        else if(type == 5)
            setImage(new GreenfootImage("pickmachine.png"));
        else if(type == 6)
            setImage(new GreenfootImage("pickshot.png"));
        else if(type == 7)
            setImage(new GreenfootImage("pickscatter.png"));
        else if(type == 8)
            setImage(new GreenfootImage("PickBomb.png"));
        else
            setImage(new GreenfootImage("bluebox.png")); //shouldn't happen
    }
    
    public int getType()
    {
        return type;
    }
    
    public int getDirection()
    {
        return direction;
    }
    
    public void act()
    {        
        if(offY()) {
            getWorld().removeObject(this);
        } else if(offX()) {
            setRotation(direction);
            move(speed);
        } else {
            move(speed);
        }
    }
    
    public void move(int y)
    {
        setLocation(getX(), getY() + y);
    }
    
    public boolean offX()
    {
        int width = getWorld().getWidth();
        int x = getX();
        
        return (x > width || x < 0); 
    }
    
    //CHECK THIS LATER
    public boolean offY()
    {
        int height = getWorld().getHeight();
        int y = getY();
        
        return (y < 0); //y > height || 
    }
    
}