import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * Protects Player from Enemys and Projectiles for a limited time.
 */

public class Shield extends Actor
{
    private int countdown;              //Duration of Shield
    private int costumeNumber; 
    private GreenfootImage[] costumes;
    private boolean isBlue; 
    
    public Shield()
    {
        countdown = 500; 
        
        //set costumes
        costumes = new GreenfootImage[4];
        for (int i = 0; i < 4; i++)
        {
            costumes[i] = new GreenfootImage("Shields_"+(i+1)+".gif");
        }
        
        costumeNumber = 0;
    }
    
    public void act()
    {
        Player p = (Player) getOneIntersectingObject(Player.class);
        
        if(p != null)
        {setLocation(p.getX(), p.getY());}
        else
        {getWorld().removeObject(this);}
        
        if(countdown % 10 == 0)
        {change();}
        
        if(countdown < 100)
        {
            if(countdown % 2 == 0)
            {
                change();
            }
        }
        
        countdown--;
        checkDamaged();

        //make costume flash first
        if(countdown <= 0)
        {
            getWorld().removeObject(this);
        }
    }
    
    public void checkDamaged()
    {
        EnemyProjectile b = (EnemyProjectile) getOneIntersectingObject(EnemyProjectile.class);
        Enemy e           = (Enemy)  getOneIntersectingObject(Enemy.class);
        Explosion splode  = new Explosion("small");
        
        // try to find an intersecting Bullet or Enemy object
        if (e != null || b!= null) //if an Enemy or a Bullet hits...
        {
            //make an Explosion and remove the object.
            setImage(costumes[3]);
            if(e != null) {
                getWorld().addObject(splode, getX(), getY());
                //getWorld().removeObject(e);
            }
            if(b != null){
                getWorld().addObject(splode, b.getX(), b.getY());
                getWorld().removeObject(b);
            }
            
            //When hit, reduce duration of shield.
            countdown -= 100;
        }
    }
     
    public void change()
    {
        if(isBlue)setImage(costumes[1]);   
        else      setImage(costumes[0]);
            
        isBlue = !isBlue;
    }
}