import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Fades in at beginning of game.
 * Creates pretty much everything when Enter key is pressed.
 */

public class TitleScreen extends Screen
{
    
    public TitleScreen()
    {
        setImage("Titlescreen1.png");
    }
    
    public void act() 
    {
        if(mode == 0)
        {
            fadeIn(); 
            if(ghost == 225)
            {
                mode = 1;
                
                getWorld().addObject(new Continue(), 250, 450);
                getWorld().addObject(new CreditScreen(), 250, 250);
                getWorld().addObject(new InstructScreen(), 250, 250);
                getWorld().addObject(new VersionScreen(), 250, 250);
            }
        }   
        
        if(mode == 1 && !play)
        {
            //make a Player (and add instructions)
            FirstLevel level = (FirstLevel)getWorld();
            //level.setSounds(new Sounds());
            level.setPlayer(new Player());
            level.setEnvironmentGenerator(new EnvironmentGenerator());
            play = true;
        }
         
        //after Enter key is pressed, make all the objects
        if(mode == 1 && Greenfoot.isKeyDown("enter"))
        {
            mode = 2;
        }
        
        if(mode == 2 && ghost > 0)
        {
            fadeOut();
        
            if(ghost == 0)
            {
                getPlayer().endIntro();
                initLevel();
                removeScreens();
                removeButtons();
                //Play awesome music
                FirstLevel level = (FirstLevel)getWorld();
                level.playMusic();
                getWorld().removeObject(this);
            }
        }
        
    }        
    
    public void initLevel()
    {
        FirstLevel level = (FirstLevel)getWorld();
       
        level.setScoreboard(new Scoreboard());
        level.setLifeCounter(new LifeCounter(5));        //five lives lifecounter
        level.setEnemyGenerator(new EnemyGenerator(0));  //stage 0 enemys
    }
    
    public void removeScreens()
    {
        FirstLevel level = (FirstLevel)getWorld();
        List<Screen> t = level.getObjects(Screen.class);
        
        for(Screen c : t)
        {
            if(!c.equals(this))
                level.removeObject(c);
        }
    }
    
    public void removeButtons()
    {
        FirstLevel level = (FirstLevel)getWorld();
        List<Button> t = level.getObjects(Button.class);
        for(Button b : t)
        { 
            level.removeObject(b);
        }
    }
}