import java.awt.geom.Point2D;

public class Toolkit  
{

    static int absoluteBearing(int x1, int y1, int x2, int y2) {
        double xo = x2-x1;
        double yo = y2-y1;
        int bearing = 0;
        int arcTan = (int)Math.toDegrees(Math.atan(yo/xo));
        
        if (xo > 0 && yo > 0) { // both pos: lower-right
            bearing = arcTan;
        } else if (xo < 0 && yo > 0) { // x neg, y pos: lower-left
            bearing = 180 + arcTan; // arcTan is negative here, actually 180 - ang
        } else if (xo > 0 && yo < 0) { // x pos, y neg: upper-right
            bearing = 360 + arcTan; // arcTan is negative here, actually 360 - ang
        } else if (xo < 0 && yo < 0) { // both neg: upper-left
            bearing = 180 + arcTan;
        }
        
        return bearing;
    }

    // computes the absolute bearing between two points
    static double oldAbsoluteBearing(double x1, double y1, double x2, double y2) {
        double xo = x2-x1;
        double yo = y2-y1;
        double hyp = Point2D.distance(x1, y1, x2, y2);
        double arcSin = Math.toDegrees(Math.asin(xo / hyp));
        double bearing = 0;
    
        if (xo > 0 && yo > 0) { // both pos: lower-Left
            bearing = arcSin;
        } else if (xo < 0 && yo > 0) { // x neg, y pos: lower-right
            bearing = 360 + arcSin; // arcsin is negative here, actuall 360 - ang
        } else if (xo > 0 && yo < 0) { // x pos, y neg: upper-left
            bearing = 180 - arcSin;
        } else if (xo < 0 && yo < 0) { // both neg: upper-right
            bearing = 180 - arcSin; // arcsin is negative here, actually 180 + ang
        }

        return bearing;
    }
}
